# This file was generated by mettle.genes.db.GenPy3 [ver 2.2] on Fri Sep 16 12:08:12 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_item_swop_id import iBatchItemSwopId

class dBatchItemSwopId:
    __slots__ = ("_dbcon", "_dbstmnt", "irec")

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchItemSwopId()

    async def __aenter__(self):
        """
        With statement enter.
        """
        return self

    async def __aexit__(self, type, value, traceback):
        """
        With statement exit.
        """
        await self._destroy()

    async def _destroy(self):
        if self._dbstmnt:
            await self._dbstmnt.destroy()
            self._dbstmnt = None

    async def exec_deft(self,
                        batch_id: int,
                        curr_id: int,
                        new_id: int) -> "dBatchItemSwopId":
        """
        Execute the query by setting all the inputs.

        :param batch_id: int
        :param curr_id: int
        :param new_id: int
        :return: Self for convenience.
        """
        self.irec.batch_id = batch_id
        self.irec.curr_id = curr_id
        self.irec.new_id = new_id

        return await self.exec()

    async def exec(self, irec: iBatchItemSwopId = None) -> "dBatchItemSwopId":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        await self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchItemSwopId", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""update
  monitor.batchitem
set
  id = :newId
where
  batch_id = :batchId and
  id       = :currId""")

        self._dbstmnt.bind_in("batchId", self.irec.batch_id, int, 8)
        self._dbstmnt.bind_in("currId", self.irec.curr_id, int, 8)
        self._dbstmnt.bind_in("newId", self.irec.new_id, int, 8)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

